define(function (require, exports, module) {
  'use strict';
  var PreferencesManager = brackets.getModule('preferences/PreferencesManager');
  var prefs = PreferencesManager.getExtensionPrefs("fonts");
  var ExtensionUtils = brackets.getModule("utils/ExtensionUtils");
  var currentValue = null;

  function adjustIMEPopup() {
    let fontSize = prefs.get("fontSize");
    let match = fontSize.match(/^([\d\.]+)(px|em)$/i);
    if (match[1]) {
      let topValue = (match[2] === "px") ?  parseFloat(match[1]) - 12 : Math.floor((parseFloat(match[1]) - 1) * 100) / 100;

      if (topValue !== currentValue) {
        let css = ".CodeMirror-wrap > div > textarea{top:" + topValue + match[2] + " !important} ";
        ExtensionUtils.addEmbeddedStyleSheet(css);
        currentValue = topValue;
      }
    }
  }
  
  adjustIMEPopup();
  prefs.on("change", "fontSize", adjustIMEPopup);
});
